<template>
  <v-card-text>
    <v-container py-0>
      <v-row no-gutters align="start">
        <v-col cols="12">
          <div v-if="item && item['organisation_name']" class="my-2">
            <v-tooltip top>
              <template v-slot:activator="{ on, attrs }">
                <v-icon v-bind="attrs" v-on="on" small class="mr-2"
                  >mdi-office-building</v-icon
                > </template
              ><span>Organisation</span></v-tooltip
            >
            <span>
              {{ item.organisation_name }}
            </span>
          </div>
          <div v-if="item && item['roles']" class="my-2">
            <v-tooltip top>
              <template v-slot:activator="{ on, attrs }">
                <v-icon small v-bind="attrs" v-on="on" class="mr-2"
                  >mdi-account-star</v-icon
                > </template
              ><span>Role(s)</span></v-tooltip
            >
            <span>
              {{ mapRoles(item.roles) }}
            </span>
          </div>
          <div v-if="item && item['tags'].length" class="my-2">
            <v-chip
              label
              small
              class="mr-1 mt-1"
              v-for="tag in item?.tags"
              :key="tag.contact_tag_id"
            >
              <v-icon small left class="mr-2">mdi-tag</v-icon>
              {{ tag.name }}</v-chip
            >
          </div>
          <div v-for="info in infos" :key="info" class="my-2">
            <v-layout
              v-if="
                item &&
                  item[info] &&
                  relatedField(info) &&
                  ['text', 'text_area'].indexOf(relatedField(info).type) !==
                    -1 &&
                  !relatedField(info).dropdown
              "
            >
              <v-tooltip top v-if="getFieldIcon(info)">
                <template v-slot:activator="{ on, attrs }">
                  <v-icon small v-bind="attrs" v-on="on" class="mr-2">
                    {{ getFieldIcon(info) }}
                  </v-icon>
                </template>
                <span>{{ relatedField(info).label }}</span>
              </v-tooltip>
              <span v-else class="mr-1"> {{ relatedField(info).label }}: </span>
              {{ item[info] }}
            </v-layout>
            <v-layout
              v-if="
                item &&
                  item[info] &&
                  relatedField(info) &&
                  relatedField(info).type === 'text' &&
                  relatedField(info).dropdown &&
                  item[info].label
              "
            >
              {{ relatedField(info).label }}: {{ item[info].label }}
            </v-layout>
            <v-layout
              v-if="
                item &&
                  item[info] &&
                  relatedField(info) &&
                  ['integer', 'phone', 'email'].indexOf(relatedField(info).type) !==
                    -1 &&
                  item[info] !== -1
              "
            >
              <v-tooltip top v-if="getFieldIcon(relatedField(info).type)">
                <template v-slot:activator="{ on, attrs }">
                  <v-icon small v-bind="attrs" v-on="on" class="mr-2">
                    {{ getFieldIcon(relatedField(info).type) }}
                  </v-icon>
                </template>
                <span>{{ relatedField(info).label }}</span>
              </v-tooltip>
              <span v-else class="mr-1"> {{ relatedField(info).label }}: </span>
              {{ relatedField(info).type === "phone" ? "+" : ""
              }}{{ item[info] }}
            </v-layout>

            <v-layout
              v-if="
                item &&
                  item[info] &&
                  relatedField(info) &&
                  ['openpgp_pubkey', 's_mime_cert'].indexOf(
                    relatedField(info).type
                  ) !== -1
              "
            >
              <v-text-field
                dense
                :label="
                  `${
                    info === 'openpgp_pubkey' ? 'OpenPGP Pubkey' : 'S/MIME Cert'
                  }`
                "
                readonly
                disabled
              >
                <template v-slot:append>
                  <v-tooltip top>
                    <template v-slot:activator="{ on, attrs }">
                      <v-icon
                        medium
                        v-bind="attrs"
                        v-on="on"
                        @click.prevent
                        v-clipboard:copy="item[info]"
                        v-clipboard:success="copyPGPContent"
                        >mdi-content-copy</v-icon
                      > </template
                    ><span>Copy to clipboard</span></v-tooltip
                  >
                  <v-tooltip top>
                    <template v-slot:activator="{ on, attrs }">
                      <v-icon
                        class="ml-1"
                        v-bind="attrs"
                        v-on="on"
                        @click="download(info)"
                        medium
                        >mdi-download</v-icon
                      > </template
                    ><span>Download</span></v-tooltip
                  >
                </template>
              </v-text-field>
            </v-layout>
            <v-layout
              v-if="
                item &&
                  item[info] &&
                  relatedField(info) &&
                  ['pdf'].indexOf(relatedField(info).type) !== -1 &&
                  item[info].id
              "
            >
              <v-text-field
                dense
                readonly
                disabled
                chips
                prepend-inner-icon="mdi-file-pdf"
                :label="item[info].name"
              >
                <template v-slot:append>
                  <v-tooltip top>
                    <template v-slot:activator="{ on, attrs }">
                      <v-icon
                        class="ml-1"
                        v-bind="attrs"
                        v-on="on"
                        @click="downloadPdf(info)"
                        medium
                        >mdi-download</v-icon
                      > </template
                    ><span>Download</span>
                  </v-tooltip>
                </template>
              </v-text-field>
            </v-layout>
          </div>
          <div v-if="item">
            <v-divider
              v-if="item['updated_at'] || item['created_at']"
            ></v-divider>
          </div>
          <div v-if="item && item['updated_at']" class="my-2">
            <span>
              Last change:
              {{ new Date(item["updated_at"]).toLocaleString() }}
              <v-icon v-if="item['is_expired']" small class="ml-2" style="color: darkorange;">mdi-clock-alert</v-icon>
            </span>
          </div>
          <div v-if="item && item['updated_by']" class="d-flex my-2">
            <span>Updated by:</span>
            <div style="max-width: 90px;" class="text-truncate ml-2">
              <a
                @click="
                  userId = item ? item['updated_by'] : '';
                  showUserInfo = true;
                "
                >{{ item["updated_by"] }}
              </a>
            </div>
          </div>
        </v-col>
        <UserInfo
          v-if="showUserInfo"
          v-bind:id="userId"
          @user-child-object="checkUserChildObject"
        />
      </v-row>
    </v-container>
    <v-snackbar v-model="isCopySuccessful" timeout="2000" text color="primary">
      Copied to clipboard
    </v-snackbar>
  </v-card-text>
</template>

<script setup lang="ts">
/*
 * This file is Free Software under GNU Affero General Public License v >= 3.0
 * without warranty, see README.md and license for details.
 *
 * SPDX-License-Identifier: AGPL-3.0-or-later
 *
 * SPDX-FileCopyrightText: 2020 nic.at GmbH <https://nic.at>
 * Software-Engineering: 2020 Intevation GmbH <https://intevation.de>
 *
 * Author(s):
 * 2021, 2022 Fadi Abbud <fadi.abbud@intevation.de>
 */
import Vue, { computed, defineAsyncComponent, ref } from "vue";
import {
  getContactFields,
  getFieldIcon,
  getUsedRoles,
  mapRoles
} from "@/lib/use-fieldbuilder";
import JSZip from "jszip";
import { saveAs } from "file-saver";
import { useUserInfo } from "@/lib/use-userinfo";

const UserInfo = defineAsyncComponent(() =>
  import("@/components/usermanagement/UserInfo.vue")
);
const props = defineProps({
  item: Object
});
const infos = computed(() => {
  if (props.item) {
    return Object.keys(props.item).filter(
      // Exclud some properties as they are not relevant to be displayed
      // or displayed/handled at another places.
      i =>
        [
          "contact_id",
          "organisation_id",
          "tags",
          "organisation_name",
          "first_name",
          "last_name",
          "roles",
          "label",
        ].indexOf(i) === -1
    );
  }
  return [];
});

const downloadPdf = info => {
  const element = document.createElement("a");
  document.body.appendChild(element);

  let path;
  let filename;

  if (props.item) {
    path = "/api/pdf/" + props.item[info].id;
    filename = props.item[info].name;
  }

  const headers = new Headers();
  headers.append("Authorization", "Bearer " + Vue.prototype.$keycloak.token);

  fetch(path, { headers }).then(response => response.blob()).then(blob => {
    element.href = window.URL.createObjectURL(blob);
    element.download = filename;
    element.click();
    document.body.removeChild(element);
  });
}
const isCopySuccessful = ref(false);
const copyPGPContent = () => {
  isCopySuccessful.value = true;
};
const download = info => {
  const zip = new JSZip();
  zip.file("public-key.text", props.item ? props.item[info] : "");
  zip
    .generateAsync({ type: "blob" })
    .then(blob => {
      saveAs(
        blob,
        `${info === "openpgp_pubkey" ? "OpenPGP pubkey" : "S/MIME Cert"} .zip`
      );
    })
    .catch(error => {
      console.log(error);
    });
};

type FieldType = { [key: string]: string };

let fields: FieldType[] = [];

if (props.item?.type !== "abusec") {
  fields = getContactFields(getUsedRoles(props.item));
} else {
  // Since Abuse-C contains only email add only one element(email) to the fields array
  fields = [{ label: "Email", name: "email", type: "text" }];
}

const relatedField = (item: string): FieldType => {
  return fields.filter(f => f["name"] === item)[0];
};

const { checkUserChildObject, userId, showUserInfo } = useUserInfo();
</script>
